/*
 * File:     IAMCollectionVTBL.java
 * Project:  MPI Linguistic Application
 * Date:     15 August 2005
 *
 * Copyright (C) 2005  Max Planck Institute for Psycholinguistics
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package mpi.eudico.client.annotator.nativemedia.quartztypelib.server;

import com.jniwrapper.Int32;
import com.jniwrapper.Parameter;
import com.jniwrapper.Pointer;

import com.jniwrapper.win32.HResult;

import com.jniwrapper.win32.automation.server.IDispatchVTBL;

import com.jniwrapper.win32.com.impl.IUnknownImpl;

import com.jniwrapper.win32.com.server.CoClassMetaInfo;


/**
 * Represents VTBL for COM interface IAMCollection
 */
public class IAMCollectionVTBL extends IDispatchVTBL {
    /**
     * Creates a new IAMCollectionVTBL instance
     *
     * @param classMetaInfo DOCUMENT ME!
     */
    public IAMCollectionVTBL(CoClassMetaInfo classMetaInfo) {
        super(classMetaInfo);

        addMembers(new VirtualMethodCallback[] {
                new VirtualMethodCallback("getCount", new HResult(),
                    new Parameter[] { new Pointer.OutOnly(new Int32()) }, 0),
                new VirtualMethodCallback("item", new HResult(),
                    new Parameter[] {
                        new Int32(), new Pointer.OutOnly(new IUnknownImpl())
                    }, 1),
                new VirtualMethodCallback("get_NewEnum", new HResult(),
                    new Parameter[] { new Pointer.OutOnly(new IUnknownImpl()) },
                    0)
            });
    }
}
